unit main;

{$ifdef fpc}
  {$MODE Delphi}
{$endif}

interface

uses
  SysUtils,
  {$ifdef Win32}
    Windows,
    {$ifdef Ver100}
      DelTime,
    {$endif}
  {$else}
    DelTime,
  {$endif}
  {$ifdef fpc}
    LCLIntf,
    LCLType,
  {$endif}
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  WolfUtil;

type
  TMainForm = class(TForm)
    Memo    : TMemo;
    procedure FormCreate(Sender: TObject);
  end;

var
  MainForm : TMainForm;

implementation

{$ifdef fpc}
  {$R *.lfm}
{$else}
  {$R *.dfm}
{$endif}

function SystemTimeToString(t : tSystemTime) : String;
  var    s : String;
  begin
    if (t.wYear = 0) and (1 <= t.wMonth) and (t.wMonth <= 12)
       and (0 <= t.wDayOfWeek) and (t.wDayOfWeek < 7) 
    then
      if t.wDay = 5 then
        s := 'letzter ' + GetLongDayName(t.wDayOfWeek + 1)
             + ' im ' + GetLongMonthName(t.wMonth)
      else
        s := IntToStr(t.wDay) + '. ' + GetLongDayName(t.wDayOfWeek + 1)
             + ' im ' + GetLongMonthName(t.wMonth)
    else
      s := IntToDez(t.wDay, 2, False) + '.'
           + IntToDez(t.wMonth, 2, False) + '.' + IntToDez(t.wYear, 4, False);
    s := s + ' ' + IntToDez(t.wHour,   2, False) + ':'
                 + IntToDez(t.wMinute, 2, False) + ':'
                 + IntToDez(t.wSecond, 2, False) + '.'
                 + IntToDez(t.wMilliseconds, 3, False);
    SystemTimeToString := s;
  end;

procedure TMainForm.FormCreate(Sender: TObject);
  var     TimeZoneInformation : TTimeZoneInformation;
          dw                  : DWord;
  begin
    Memo.Align               := alClient;
    TimeZoneInformation.Bias := 0;
    dw                       := GetTimeZoneInformation(TimeZoneInformation);
    case dw of
      TIME_ZONE_ID_UNKNOWN  : Memo.Lines.Add('TIME_ZONE_ID_UNKNOWN');
      TIME_ZONE_ID_STANDARD : Memo.Lines.Add('TIME_ZONE_ID_STANDARD');
      TIME_ZONE_ID_DAYLIGHT : Memo.Lines.Add('TIME_ZONE_ID_DAYLIGHT');
    else
      {$ifdef Win32}
        Memo.Lines.Add(SysErrorMessage(GetLastError));
      {$else}
        Memo.Lines.Add('Error $' + IntToHex(dw, 8));
      {$endif}
    end;
    Memo.Lines.Add('Bias         : ' + IntToStr(TimeZoneInformation.Bias));
    Memo.Lines.Add('StandardName : ' +
                      CP1252ToSystem(WideCharToString(
                        TimeZoneInformation.StandardName)));
    Memo.Lines.Add('StandardDate : ' +
                      SystemTimeToString(TimeZoneInformation.StandardDate));
    Memo.Lines.Add('StandardBias : ' +
                      IntToStr(TimeZoneInformation.StandardBias));
    Memo.Lines.Add('DaylightName : ' +
                      CP1252ToSystem(WideCharToString(
                        TimeZoneInformation.DaylightName)));
    Memo.Lines.Add('DaylightDate : ' +
                      SystemTimeToString(TimeZoneInformation.DaylightDate));
    Memo.Lines.Add('DaylightBias : ' +
                      IntToStr(TimeZoneInformation.DaylightBias));
  end;

end.
